import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Frame;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;

class CommentaireDlg extends JDialog implements ActionListener {

	private Commentaire commentaire;
	private JTextField commentaireField;

	public CommentaireDlg (Frame parent, String titre, Commentaire commentaire) {
		super (parent, titre, true);
		this.commentaire = commentaire;
		JLabel commentaireLbl = new JLabel ("Commentaire");
		commentaireField = new JTextField (20);
		JButton annuler = new JButton ("annuler");
		JButton valider = new JButton ("valider");
		GridBagConstraints gc = new GridBagConstraints();
		GridBagLayout layout = new GridBagLayout ();
		getContentPane().setLayout(layout);
		gc.gridx=0;
		gc.gridy=0;
		gc.gridwidth=2;
		layout.setConstraints (commentaireLbl, gc);
		getContentPane().add(commentaireLbl);
		gc.gridy=1;
		layout.setConstraints (commentaireField, gc);
		getContentPane().add(commentaireField);
		gc.gridwidth=1;
		gc.gridy=2;
		gc.anchor=GridBagConstraints.WEST;
		layout.setConstraints (valider, gc);
		valider.addActionListener (this);
		valider.setActionCommand ("valider");
		getContentPane().add(valider);
		gc.gridx=1;
		gc.anchor=GridBagConstraints.EAST;
		layout.setConstraints (annuler, gc);
		annuler.addActionListener (this);
		annuler.setActionCommand ("annuler");
		getContentPane().add(annuler);
		setResizable (false);
		setLocationRelativeTo (parent);
		pack ();
		setVisible (true);
	}

	public void actionPerformed (ActionEvent event) {
		String cmd = event.getActionCommand();
		if (cmd.equals("valider")) {
			commentaire.setCommentaire (commentaireField.getText());
			commentaire.setValide (true);
			dispose ();
		}
		else if (cmd.equals("annuler")) {
			commentaire.setValide(false);
			dispose();
		}
	}

}
