import java.io.*;
import java.util.Properties;

public class DetectionOutils {
	
	public final static int LANG_C = 0;
	public final static int LANG_CPP = 1;
	public final static int LANG_DBASE = 2;
	public final static int LANG_JAVA = 3;
	public final static int LANG_PASCAL = 4;
	public final static int LANG_PERL = 5;
	public final static int LANG_REXX = 6;
	public final static int LANG_TCL = 7;
	public final static int GALG = 8;
	
	private final static int NB_LANG = 9;
	
	private static String[] langages; 
	
	public DetectionOutils () {
		langages = new String[NB_LANG];
		detectGcc();
		if (langages[LANG_C]==null)
				System.out.println ("gcc non dtect");
		else
				System.out.println ("gcc v"+langages[LANG_C]+" dtect");
		detectCpp();
		if (langages[LANG_CPP]==null)
				System.out.println ("g++ non dtect");
		else
				System.out.println ("g++ v"+langages[LANG_CPP]+" dtect");
		detectDBase();
				if (langages[LANG_DBASE]==null)
				System.out.println ("DBase non dtect");
		else
				System.out.println ("DBase v"+langages[LANG_DBASE]+" dtect");
		detectJava();
		if (langages[LANG_JAVA]==null)
				System.out.println ("java non dtect");
		else
				System.out.println ("java v"+langages[LANG_JAVA]+" dtect");
		detectPascal();
		if (langages[LANG_PASCAL]==null)
				System.out.println ("ppc386 non dtect");
		else
				System.out.println ("ppc386 v"+langages[LANG_PASCAL]+" dtect");
		detectPerl();
		if (langages[LANG_PERL]==null)
				System.out.println ("perl non dtect");
		else
				System.out.println ("perl v"+langages[LANG_PERL]+" dtect");
		detectRexx();
		if (langages[LANG_REXX]==null)
				System.out.println ("Regina non dtect");
		else
				System.out.println ("Regina v"+langages[LANG_REXX]+" dtect");
		detectTcl();
		if (langages[LANG_TCL]==null)
				System.out.println ("tclsh non dtect");
		else
				System.out.println ("tclsh v"+langages[LANG_C]+" dtect");
		detectGalg();
		if (langages[GALG]==null)
				System.out.println ("Galg non dtect");
		else
				System.out.println ("Galg v"+langages[LANG_C]+" dtect");
	}
	
	// getExecute xcute une commande passe en paramtre et renvoie sa sortie (stderr ou stdout)
	private String getExecute (String command, String canal) {
		try {
			Process p = Runtime.getRuntime().exec(command);
			p.waitFor();
			InputStream resultat;
			if (canal.equals("stderr"))
				resultat = new BufferedInputStream (p.getErrorStream());
			else
				resultat = new BufferedInputStream (p.getInputStream());
			byte[] buffer = new byte[4096];
			int res=resultat.read(buffer);
			while (res!=-1)
				res=resultat.read(buffer);
			resultat.close();
			return new String (buffer);
		}
		catch (IOException except) {
			return null;
		}
		catch (InterruptedException except) {
			return null;
		}
	}
	
	// Dtection de Gcc
	private void detectGcc () {
			String sortie = getExecute ("gcc -v", "stderr");
			if (sortie!=null) { 
				String[] tableau;
				int index;
				if ((index=sortie.indexOf ("version"))!=-1) {	
					sortie = sortie.substring(index);
					tableau=sortie.split(" ");
					String[] tab2;
					tab2=tableau[1].split("\n");
					langages[LANG_C]= new String (tab2[0]);
				}
			}
	}
	
	// Dtection de G++
	private void detectCpp () {
		String sortie = getExecute ("g++ -v", "stderr");
		if (sortie!=null) {
			String[] tableau;
			int index;
			if ((index=sortie.indexOf ("version"))!=-1) {	
				sortie = sortie.substring(index);
				tableau=sortie.split(" ");
				String[] tab2;
				tab2=tableau[1].split("\n");
				langages[LANG_CPP]=new String (tab2[0]);
			}
		}
	}
	
	private void detectDBase () {
	}
	
	private void detectJava () {
		String sortie = getExecute ("java -version", "stderr");
		if (sortie!=null) {
			String[] tableau;
			int index;
			if ((index=sortie.indexOf ("\""))!=-1) {	
				sortie = sortie.substring(++index);
				tableau=sortie.split("\"");
				langages[LANG_JAVA]=new String (tableau[0]);
			}
		}
	}
	
	private void detectPascal () {
		String sortie = getExecute ("ppc386 -iV","stdout");
		if (sortie!=null) {
				String[] tab2;
		tab2=sortie.split("\n");
		langages[LANG_PASCAL]=new String (tab2[0]);
		}
	}
	
	private void detectPerl () {
			Properties prop=System.getProperties();
			String sortie;
			if (prop.getProperty("os.name").equals("Linux"))
					sortie = getExecute ("perl -v", "stdout");
			else
					sortie = getExecute ("COMMAND.COM /C perl -v","stdout");
		if (sortie!=null) {
			int index;
			String[] tableau;
			if ((index=sortie.indexOf("v"))!=-1) {
				sortie=sortie.substring(++index);
				tableau=sortie.split(" ");
				langages[LANG_PERL]=new String(tableau[0]);
			}
		}
	}
	
	private void detectRexx () {
		String sortie = getExecute ("regina versionRexx.rex","stdout");
		if (sortie==null)
			langages[LANG_REXX]=null;
		else {
			String[] tableau;
			tableau=sortie.split(" ");
			langages[LANG_REXX]=new String(tableau[0]+" "+tableau[1]);
		}
	}
	
	private void detectTcl () {
		String sortie = getExecute ("tclsh versionTcl.tcl","stdout");
		if (sortie!=null) {
			String[] tableau;
			tableau=sortie.split("\n");               // Ncessaire car la chane renvoye comporte une anomalie
			langages[LANG_TCL]=tableau[0];
		}
	}
	
		private void detectGalg () {
				String sortie;
				sortie = getExecute ("galg","stdout");
				if (sortie!=null) {
						String[] tableau;
						int index;
						if ((index=sortie.indexOf ("version"))!=-1) {
				index+=1+"version".length();
				sortie=sortie.substring(index);
				tableau=sortie.split(" ");
				langages[GALG]=new String (tableau[0]);
						}
				}
		}
	
	// Accesseurs
	
	public String getVersion (int langage) {
		return langages[langage];
	}
	
}
