import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.CaretEvent;
import javax.swing.text.BadLocationException;
import javax.swing.JTextArea;
import javax.swing.JOptionPane;

public class Editeur extends JTextArea implements DocumentListener, CaretListener {

	private BarreDeStatut barreDeStatut;
	private MainFrame mainFrame;

	public Editeur (MainFrame mainFrame, BarreDeStatut barreDeStatut) {
		super();
		this.barreDeStatut=barreDeStatut;
		this.mainFrame=mainFrame;
		getDocument().addDocumentListener (this);
		addCaretListener (this);
	}
	
	private void majBarreDeStatut () {
		if (mainFrame.getModifie()==false) {
			mainFrame.setModifie (true);
			barreDeStatut.setNomFichier(mainFrame.getFichierAlg()+" (modifi)");
		}
	}
	
	public void removeUpdate (DocumentEvent event) {
		majBarreDeStatut ();
	}
	
	public void insertUpdate (DocumentEvent event) {
		majBarreDeStatut ();
	}
	
	public void changedUpdate (DocumentEvent event) {
		// Ce message n'est jamais envoy car nous travaillons avec du texte brut 
	}
	
	public void caretUpdate (CaretEvent event) {
		try {
			int position = getCaretPosition ();
			int ligne,colonne;
			if ((ligne=getLineOfOffset(position))==0) {
				ligne=0;
				colonne=position;
			}
			else 
				colonne=position-getLineEndOffset(getLineOfOffset(position)-1);
			ligne++;colonne++;
			barreDeStatut.setCoordonnees ("Ligne "+ligne+", Colonne "+colonne);				
		}
		catch (BadLocationException except) {
			JOptionPane.showMessageDialog(this,"Une erreur est survenue pendant la mise  jour de la position du symbole d'insertion","Erreur",JOptionPane.ERROR_MESSAGE);		
		}
	}
	
}
