import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Frame;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

class LigneDlg extends JDialog implements ActionListener {
	
	private Ligne ligne;
	private JTextField numeroField;
	private int nblignes;
	
	public LigneDlg (Frame parent, String titre, Ligne ligne, int nblignes) {
		super (parent, titre, true);
		this.ligne=ligne;
		this.nblignes=nblignes;
		numeroField = new JTextField (20);
		JLabel numeroLbl = new JLabel ("Numro de la ligne (1-"+nblignes+")");
		JButton valider = new JButton ("valider");
		JButton annuler = new JButton ("annuler");
		GridBagLayout layout = new GridBagLayout ();
		GridBagConstraints gc = new GridBagConstraints ();
		getContentPane().setLayout(layout);
		gc.gridx=0;
		gc.gridy=0;
		gc.gridwidth=2;
		layout.setConstraints (numeroLbl,gc);
		getContentPane().add(numeroLbl);
		gc.gridy=1;
		layout.setConstraints (numeroField,gc);
		getContentPane().add(numeroField);
		gc.anchor=GridBagConstraints.WEST;
		gc.gridwidth=1;
		gc.gridy=2;
		layout.setConstraints (valider,gc);
		valider.addActionListener (this);
		valider.setActionCommand ("valider");
		getContentPane().add(valider);		
		gc.gridx=1;
		gc.anchor=GridBagConstraints.EAST;
		layout.setConstraints (annuler,gc);
		annuler.addActionListener(this);
		annuler.setActionCommand("annuler");
		getContentPane().add(annuler);
		setResizable (false);
		setLocationRelativeTo (parent);
		pack ();
		setVisible (true);
	}
	
	public void actionPerformed (ActionEvent event) {
		String cmd = event.getActionCommand();
		if (cmd.equals("annuler")) {
			ligne.setValide (false);
			dispose ();
		}
		else if (cmd.equals("valider")) {
			if (numeroField.getText().equals(""))
				JOptionPane.showMessageDialog(this,"Vous devez renseigner le champ \"Numro de la ligne\"","Erreur",JOptionPane.ERROR_MESSAGE);
			else {
				ligne.setValide(true);
				try {
					if (Integer.parseInt(numeroField.getText())<=nblignes) {
						ligne.setNumero(Integer.parseInt(numeroField.getText()));
						dispose ();
					}
					else 
						JOptionPane.showMessageDialog (this,"Numro de ligne invalide","Erreur",JOptionPane.ERROR_MESSAGE);
				}
				catch (NumberFormatException except) {
					JOptionPane.showMessageDialog (this,"Numro de ligne invalide","Erreur",JOptionPane.ERROR_MESSAGE);
				}
			}
		}
	}
	
}
